#pragma once

#include "input.cpp"
#include "one_pair.cpp"
#include "all_pair.cpp"
#include <chrono>

using namespace std;

void solve_one_pair(Problem problem){
    OnePair OnePair;
    OnePair.solve(problem);
}

void solve_all_pair(Problem problem){
    AllPair AllPair;
    AllPair.solve(problem);
}

int main(){
    // auto start = std::chrono::high_resolution_clock::now();
    Problem problem;
    problem.Input();

    // std::cerr<<"l := "<<problem.l<<std::endl;
    // std::cerr<<"n := "<<problem.n<<", m := "<<problem.m<<std::endl;
    // std::cerr<<"s := "<<problem.s<<", t := "<<problem.t<<std::endl;


    if(problem.s == -1){
        solve_all_pair(problem);
    }else{
        solve_one_pair(problem);
    }

    // auto end = std::chrono::high_resolution_clock::now();
    // std::chrono::duration<double> elapsed = end - start;

    // std::cerr << "Elapsed time: " << elapsed.count() << "s\n";
}