#pragma once

#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include <vector>
#include <utility>

class Problem{
public:
    std::vector<std::vector<int>> edges;
    int n, m;
    int l;
    int s = -1, t = -1;

    Problem(){
 
    }
    
    void Input(){
	    std::string str;

        std::vector<std::pair<int, int>> fall_edges;

	    while (std::getline(std::cin, str)) {
	        std::stringstream ss(str);
            char ope;
            ss >> ope;
            if(ope == 'e'){
                int v1, v2;
                ss >> v1 >> v2;
                fall_edges.push_back(std::make_pair(v1, v2));
            }else if(ope == 't'){
                ss >> s >> t;
                s--, t--;
            }else if(ope == 'l'){
                ss >> l;
            }else if(ope == 'p'){
                std::string edge;
                ss >> edge >> n >> m;
            }
        }

        edges.resize(n);

        for(auto p : fall_edges){
            edges[p.first - 1].push_back(p.second - 1);
            edges[p.second - 1].push_back(p.first - 1);
        }
	    return;
    }
};